/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSAnimationContext;

import dstep.appkit.AppKitDefines;
import dstep.foundation.NSDate;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSAnimationContext : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	static void beginGrouping ()
	{
		return invokeObjcSelfClass!(void, "beginGrouping");
	}

	static void endGrouping ()
	{
		return invokeObjcSelfClass!(void, "endGrouping");
	}

	static NSAnimationContext currentContext ()
	{
		return invokeObjcSelfClass!(NSAnimationContext, "currentContext");
	}

	void setDuration (double duration)
	{
		return invokeObjcSelf!(void, "setDuration:", double)(duration);
	}

	double duration ()
	{
		return invokeObjcSelf!(double, "duration");
	}
}

