/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSCachedImageRep;

import dstep.appkit.NSGraphics;
import dstep.appkit.NSImageRep;
import dstep.appkit.NSWindow;
import dstep.foundation.NSGeometry;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSCachedImageRep : NSImageRep
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	NSCachedImageRep initWithWindow (NSWindow win, NSRect rect)
	{
		id result = invokeObjcSelf!(id, "initWithWindow:rect:", NSWindow, NSRect)(win, rect);
		return result is this.objcObject ? this : (result !is null ? new NSCachedImageRep(result) : null);
	}

	this (NSWindow win, NSRect rect)
	{
		super(NSCachedImageRep.alloc.initWithWindow(win, rect).objcObject);
	}

	NSCachedImageRep initWithSize (NSSize size, int depth, bool flag, bool alpha)
	{
		id result = invokeObjcSelf!(id, "initWithSize:depth:separate:alpha:", NSSize, int, bool, bool)(size, depth, flag, alpha);
		return result is this.objcObject ? this : (result !is null ? new NSCachedImageRep(result) : null);
	}

	this (NSSize size, int depth, bool flag, bool alpha)
	{
		super(NSCachedImageRep.alloc.initWithSize(size, depth, flag, alpha).objcObject);
	}

	NSWindow window ()
	{
		return invokeObjcSelf!(NSWindow, "window");
	}

	NSRect rect ()
	{
		return invokeObjcSelf!(NSRect, "rect");
	}
}

