/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSPICTImageRep;

import dstep.appkit.NSImageRep;
import dstep.foundation.NSData;
import dstep.foundation.NSGeometry;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSPICTImageRep : NSImageRep
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	static Object imageRepWithData (NSData pictData)
	{
		return invokeObjcSelfClass!(Object, "imageRepWithData:", NSData)(pictData);
	}

	NSPICTImageRep initWithData (NSData pictData)
	{
		id result = invokeObjcSelf!(id, "initWithData:", NSData)(pictData);
		return result is this.objcObject ? this : (result !is null ? new NSPICTImageRep(result) : null);
	}

	this (NSData pictData)
	{
		super(NSPICTImageRep.alloc.initWithData(pictData).objcObject);
	}

	NSData PICTRepresentation ()
	{
		return invokeObjcSelf!(NSData, "PICTRepresentation");
	}

	NSRect boundingBox ()
	{
		return invokeObjcSelf!(NSRect, "boundingBox");
	}
}

