/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSPathComponentCell;

import dstep.appkit.NSImage;
import dstep.appkit.NSTextFieldCell;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.foundation.NSURL;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSPathComponentCell : NSTextFieldCell
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	NSImage image ()
	{
		return invokeObjcSelf!(NSImage, "image");
	}

	void setImage (NSImage value)
	{
		return invokeObjcSelf!(void, "setImage:", NSImage)(value);
	}

	NSURL URL ()
	{
		return invokeObjcSelf!(NSURL, "URL");
	}

	void setURL (NSURL url)
	{
		return invokeObjcSelf!(void, "setURL:", NSURL)(url);
	}
}

