/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSSearchField;

import dstep.appkit.NSTextField;
import dstep.foundation.NSArray;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSSearchField : NSTextField
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	void setRecentSearches (NSArray searches)
	{
		return invokeObjcSelf!(void, "setRecentSearches:", NSArray)(searches);
	}

	NSArray recentSearches ()
	{
		return invokeObjcSelf!(NSArray, "recentSearches");
	}

	void setRecentsAutosaveName (NSString string)
	{
		return invokeObjcSelf!(void, "setRecentsAutosaveName:", NSString)(string);
	}

	NSString recentsAutosaveName ()
	{
		return invokeObjcSelf!(NSString, "recentsAutosaveName");
	}
}

