/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSStatusBar;

import dstep.appkit.NSColor;
import dstep.appkit.NSFont;
import dstep.appkit.NSStatusItem;
import dstep.applicationservices.coregraphics.CGBase;
import dstep.foundation.NSGeometry;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSStatusBar : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	static NSStatusBar systemStatusBar ()
	{
		return invokeObjcSelfClass!(NSStatusBar, "systemStatusBar");
	}

	NSStatusItem statusItemWithLength (CGFloat length)
	{
		return invokeObjcSelf!(NSStatusItem, "statusItemWithLength:", CGFloat)(length);
	}

	void removeStatusItem (NSStatusItem item)
	{
		return invokeObjcSelf!(void, "removeStatusItem:", NSStatusItem)(item);
	}

	bool isVertical ()
	{
		return invokeObjcSelf!(bool, "isVertical");
	}

	CGFloat thickness ()
	{
		return invokeObjcSelf!(CGFloat, "thickness");
	}
}

