/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGPSConverter;

import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFDictionary;
import dstep.corefoundation.CFString;
import dstep.applicationservices.coregraphics.CGBase;
import dstep.applicationservices.coregraphics.CGDataConsumer;
import dstep.applicationservices.coregraphics.CGDataProvider;

struct CGPSConverter;

alias CGPSConverter* CGPSConverterRef;

extern (C)
{
	alias void function (void*, bool) CGPSConverterEndDocumentCallback;
	alias void function (void*) CGPSConverterProgressCallback;
	alias void function (void*, uint, CFDictionaryRef) CGPSConverterEndPageCallback;
	alias void function (void*, uint, CFDictionaryRef) CGPSConverterBeginPageCallback;
	alias void function (void*) CGPSConverterReleaseInfoCallback;
	alias void function (void*, CFStringRef) CGPSConverterMessageCallback;
	alias void function (void*) CGPSConverterBeginDocumentCallback;
}

struct CGPSConverterCallbacks
{
	uint version_;
	CGPSConverterBeginDocumentCallback beginDocument;
	CGPSConverterEndDocumentCallback endDocument;
	CGPSConverterBeginPageCallback beginPage;
	CGPSConverterEndPageCallback endPage;
	CGPSConverterProgressCallback noteProgress;
	CGPSConverterMessageCallback noteMessage;
	CGPSConverterReleaseInfoCallback releaseInfo;
}

extern (C)
{
	CGPSConverterRef CGPSConverterCreate (void* info, CGPSConverterCallbacks* callbacks, CFDictionaryRef options);
	bool CGPSConverterConvert (CGPSConverterRef converter, CGDataProviderRef provider, CGDataConsumerRef consumer, CFDictionaryRef options);
	bool CGPSConverterAbort (CGPSConverterRef converter);
	bool CGPSConverterIsConverting (CGPSConverterRef converter);
	uint CGPSConverterGetTypeID ();
}