/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 21, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coreservices.ae.AERegistry;

//import dstep.AvailabilityMacros;
import dstep.coreservices.ae.AEDataModel;
import dstep.coreservices.ae.AppleEvents;
import dstep.coreservices.carboncore.CarbonCore;
import dstep.objc.bridge.TypeEncoding;

alias TextRange* TextRangePtr;
alias TextRangePtr* TextRangeHandle;
alias TextRangeArray* TextRangeArrayPtr;
alias TextRangeArrayPtr* TextRangeArrayHandle;
alias OffsetArray*[][] OffsetArrayPtr;
alias OffsetArrayPtr* OffsetArrayHandle;

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __cAEList = getOSType!("list");
		const __cApplication = getOSType!("capp");
		const __cArc = getOSType!("carc");
		const __cBoolean = getOSType!("bool");
		const __cCell = getOSType!("ccel");
		const __cChar = getOSType!("cha ");
		const __cColorTable = getOSType!("clrt");
		const __cColumn = getOSType!("ccol");
		const __cDocument = getOSType!("docu");
		const __cDrawingArea = getOSType!("cdrw");
		const __cEnumeration = getOSType!("enum");
		const __cFile = getOSType!("file");
		const __cFixed = getOSType!("fixd");
		const __cFixedPoint = getOSType!("fpnt");
		const __cFixedRectangle = getOSType!("frct");
		const __cGraphicLine = getOSType!("glin");
		const __cGraphicObject = getOSType!("cgob");
		const __cGraphicShape = getOSType!("cgsh");
		const __cGraphicText = getOSType!("cgtx");
		const __cGroupedGraphic = getOSType!("cpic");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __cInsertionLoc = getOSType!("insl");
		const __cInsertionPoint = getOSType!("cins");
		const __cIntlText = getOSType!("itxt");
		const __cIntlWritingCode = getOSType!("intl");
		const __cItem = getOSType!("citm");
		const __cLine = getOSType!("clin");
		const __cLongDateTime = getOSType!("ldt ");
		const __cLongFixed = getOSType!("lfxd");
		const __cLongFixedPoint = getOSType!("lfpt");
		const __cLongFixedRectangle = getOSType!("lfrc");
		const __cLongInteger = getOSType!("long");
		const __cLongPoint = getOSType!("lpnt");
		const __cLongRectangle = getOSType!("lrct");
		const __cMachineLoc = getOSType!("mLoc");
		const __cMenu = getOSType!("cmnu");
		const __cMenuItem = getOSType!("cmen");
		const __cObject = getOSType!("cobj");
		const __cObjectSpecifier = getOSType!("obj ");
		const __cOpenableObject = getOSType!("coob");
		const __cOval = getOSType!("covl");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __cParagraph = getOSType!("cpar");
		const __cPICT = getOSType!("PICT");
		const __cPixel = getOSType!("cpxl");
		const __cPixelMap = getOSType!("cpix");
		const __cPolygon = getOSType!("cpgn");
		const __cProperty = getOSType!("prop");
		const __cQDPoint = getOSType!("QDpt");
		const __cQDRectangle = getOSType!("qdrt");
		const __cRectangle = getOSType!("crec");
		const __cRGBColor = getOSType!("cRGB");
		const __cRotation = getOSType!("trot");
		const __cRoundedRectangle = getOSType!("crrc");
		const __cRow = getOSType!("crow");
		const __cSelection = getOSType!("csel");
		const __cShortInteger = getOSType!("shor");
		const __cTable = getOSType!("ctbl");
		const __cText = getOSType!("ctxt");
		const __cTextFlow = getOSType!("cflo");
		const __cTextStyles = getOSType!("tsty");
		const __cType = getOSType!("type");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __cVersion = getOSType!("vers");
		const __cWindow = getOSType!("cwin");
		const __cWord = getOSType!("cwor");
		const __enumArrows = getOSType!("arro");
		const __enumJustification = getOSType!("just");
		const __enumKeyForm = getOSType!("kfrm");
		const __enumPosition = getOSType!("posi");
		const __enumProtection = getOSType!("prtn");
		const __enumQuality = getOSType!("qual");
		const __enumSaveOptions = getOSType!("savo");
		const __enumStyle = getOSType!("styl");
		const __enumTransferMode = getOSType!("tran");
		const __kAEAbout = getOSType!("abou");
		const __kAEAfter = getOSType!("afte");
		const __kAEAliasSelection = getOSType!("sali");
		const __kAEAllCaps = getOSType!("alcp");
		const __kAEArrowAtEnd = getOSType!("aren");
		const __kAEArrowAtStart = getOSType!("arst");
		const __kAEArrowBothEnds = getOSType!("arbo");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kAEAsk = getOSType!("ask ");
		const __kAEBefore = getOSType!("befo");
		const __kAEBeginning = getOSType!("bgng");
		const __kAEBeginsWith = getOSType!("bgwt");
		const __kAEBeginTransaction = getOSType!("begi");
		const __kAEBold = getOSType!("bold");
		const __kAECaseSensEquals = getOSType!("cseq");
		const __kAECentered = getOSType!("cent");
		const __kAEChangeView = getOSType!("view");
		const __kAEClone = getOSType!("clon");
		const __kAEClose = getOSType!("clos");
		const __kAECondensed = getOSType!("cond");
		const __kAEContains = getOSType!("cont");
		const __kAECopy = getOSType!("copy");
		const __kAECoreSuite = getOSType!("core");
		const __kAECountElements = getOSType!("cnte");
		const __kAECreateElement = getOSType!("crel");
		const __kAECreatePublisher = getOSType!("cpub");
		const __kAECut = getOSType!("cut ");
		const __kAEDelete = getOSType!("delo");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kAEDoObjectsExist = getOSType!("doex");
		const __kAEDoScript = getOSType!("dosc");
		const __kAEDrag = getOSType!("drag");
		const __kAEDuplicateSelection = getOSType!("sdup");
		const __kAEEditGraphic = getOSType!("edit");
		const __kAEEmptyTrash = getOSType!("empt");
		const __kAEEnd = getOSType!("end ");
		const __kAEEndsWith = getOSType!("ends");
		const __kAEEndTransaction = getOSType!("endt");
		const __kAEEquals = getOSType!("=   ");
		const __kAEExpanded = getOSType!("pexp");
		const __kAEFast = getOSType!("fast");
		const __kAEFinderEvents = getOSType!("FNDR");
		const __kAEFormulaProtect = getOSType!("fpro");
		const __kAEFullyJustified = getOSType!("full");
		const __kAEGetClassInfo = getOSType!("qobj");
		const __kAEGetData = getOSType!("getd");
		const __kAEGetDataSize = getOSType!("dsiz");
		const __kAEGetEventInfo = getOSType!("gtei");
		const __kAEGetInfoSelection = getOSType!("sinf");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kAEGetPrivilegeSelection = getOSType!("sprv");
		const __kAEGetSuiteInfo = getOSType!("gtsi");
		const __kAEGreaterThan = getOSType!(">   ");
		const __kAEGreaterThanEquals = getOSType!(">=  ");
		const __kAEGrow = getOSType!("grow");
		const __kAEHidden = getOSType!("hidn");
		const __kAEHiQuality = getOSType!("hiqu");
		const __kAEImageGraphic = getOSType!("imgr");
		const __kAEIsUniform = getOSType!("isun");
		const __kAEItalic = getOSType!("ital");
		const __kAELeftJustified = getOSType!("left");
		const __kAELessThan = getOSType!("<   ");
		const __kAELessThanEquals = getOSType!("<=  ");
		const __kAELowercase = getOSType!("lowc");
		const __kAEMakeObjectsVisible = getOSType!("mvis");
		const __kAEMiscStandards = getOSType!("misc");
		const __kAEModifiable = getOSType!("modf");
		const __kAEMove = getOSType!("move");
		const __kAENo = getOSType!("no  ");
		const __kAENoArrow = getOSType!("arno");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kAENonmodifiable = getOSType!("nmod");
		const __kAEOpen = getOSType!("odoc");
		const __kAEOpenSelection = getOSType!("sope");
		const __kAEOutline = getOSType!("outl");
		const __kAEPageSetup = getOSType!("pgsu");
		const __kAEPaste = getOSType!("past");
		const __kAEPlain = getOSType!("plan");
		const __kAEPrint = getOSType!("pdoc");
		const __kAEPrintSelection = getOSType!("spri");
		const __kAEPrintWindow = getOSType!("pwin");
		const __kAEPutAwaySelection = getOSType!("sput");
		const __kAEQDAddOver = getOSType!("addo");
		const __kAEQDAddPin = getOSType!("addp");
		const __kAEQDAdMax = getOSType!("admx");
		const __kAEQDAdMin = getOSType!("admn");
		const __kAEQDBic = getOSType!("bic ");
		const __kAEQDBlend = getOSType!("blnd");
		const __kAEQDCopy = getOSType!("cpy ");
		const __kAEQDNotBic = getOSType!("nbic");
		const __kAEQDNotCopy = getOSType!("ncpy");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kAEQDNotOr = getOSType!("ntor");
		const __kAEQDNotXor = getOSType!("nxor");
		const __kAEQDOr = getOSType!("or  ");
		const __kAEQDSubOver = getOSType!("subo");
		const __kAEQDSubPin = getOSType!("subp");
		const __kAEQDSupplementalSuite = getOSType!("qdsp");
		const __kAEQDXor = getOSType!("xor ");
		const __kAEQuickdrawSuite = getOSType!("qdrw");
		const __kAEQuitAll = getOSType!("quia");
		const __kAERedo = getOSType!("redo");
		const __kAERegular = getOSType!("regl");
		const __kAEReopenApplication = getOSType!("rapp");
		const __kAEReplace = getOSType!("rplc");
		const __kAERequiredSuite = getOSType!("reqd");
		const __kAERestart = getOSType!("rest");
		const __kAERevealSelection = getOSType!("srev");
		const __kAERevert = getOSType!("rvrt");
		const __kAERightJustified = getOSType!("rght");
		const __kAESave = getOSType!("save");
		const __kAESelect = getOSType!("slct");
		const __kAESetData = getOSType!("setd");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kAESetPosition = getOSType!("posn");
		const __kAEShadow = getOSType!("shad");
		const __kAEShowClipboard = getOSType!("shcl");
		const __kAEShutDown = getOSType!("shut");
		const __kAESleep = getOSType!("slep");
		const __kAESmallCaps = getOSType!("smcp");
		const __kAESpecialClassProperties = getOSType!("c@#!");
		const __kAEStrikethrough = getOSType!("strk");
		const __kAESubscript = getOSType!("sbsc");
		const __kAESuperscript = getOSType!("spsc");
		const __kAETableSuite = getOSType!("tbls");
		const __kAETextSuite = getOSType!("TEXT");
		const __kAETransactionTerminated = getOSType!("ttrm");
		const __kAEUnderline = getOSType!("undl");
		const __kAEUndo = getOSType!("undo");
		const __kAEWholeWordEquals = getOSType!("wweq");
		const __kAEYes = getOSType!("yes ");
		const __kAEZoom = getOSType!("zoom");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kAELogOut = getOSType!("logo");
		const __kAEReallyLogOut = getOSType!("rlgo");
		const __kAEShowRestartDialog = getOSType!("rrst");
		const __kAEShowShutdownDialog = getOSType!("rsdn");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kAEMouseClass = getOSType!("mous");
		const __kAEDown = getOSType!("down");
		const __kAEUp = getOSType!("up  ");
		const __kAEMoved = getOSType!("move");
		const __kAEStoppedMoving = getOSType!("stop");
		const __kAEWindowClass = getOSType!("wind");
		const __kAEUpdate = getOSType!("updt");
		const __kAEActivate = getOSType!("actv");
		const __kAEDeactivate = getOSType!("dact");
		const __kAECommandClass = getOSType!("cmnd");
		const __kAEKeyClass = getOSType!("keyc");
		const __kAERawKey = getOSType!("rkey");
		const __kAEVirtualKey = getOSType!("keyc");
		const __kAENavigationKey = getOSType!("nave");
		const __kAEAutoDown = getOSType!("auto");
		const __kAEApplicationClass = getOSType!("appl");
		const __kAESuspend = getOSType!("susp");
		const __kAEResume = getOSType!("rsme");
		const __kAEDiskEvent = getOSType!("disk");
		const __kAENullEvent = getOSType!("null");
		const __kAEWakeUpEvent = getOSType!("wake");
		const __kAEScrapEvent = getOSType!("scrp");
		const __kAEHighLevel = getOSType!("high");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __keyAEAngle = getOSType!("kang");
		const __keyAEArcAngle = getOSType!("parc");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __keyAEBaseAddr = getOSType!("badd");
		const __keyAEBestType = getOSType!("pbst");
		const __keyAEBgndColor = getOSType!("kbcl");
		const __keyAEBgndPattern = getOSType!("kbpt");
		const __keyAEBounds = getOSType!("pbnd");
		const __keyAECellList = getOSType!("kclt");
		const __keyAEClassID = getOSType!("clID");
		const __keyAEColor = getOSType!("colr");
		const __keyAEColorTable = getOSType!("cltb");
		const __keyAECurveHeight = getOSType!("kchd");
		const __keyAECurveWidth = getOSType!("kcwd");
		const __keyAEDashStyle = getOSType!("pdst");
		const __keyAEData = getOSType!("data");
		const __keyAEDefaultType = getOSType!("deft");
		const __keyAEDefinitionRect = getOSType!("pdrt");
		const __keyAEDescType = getOSType!("dstp");
		const __keyAEDestination = getOSType!("dest");
		const __keyAEDoAntiAlias = getOSType!("anta");
		const __keyAEDoDithered = getOSType!("gdit");
		const __keyAEDoRotate = getOSType!("kdrt");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __keyAEDoScale = getOSType!("ksca");
		const __keyAEDoTranslate = getOSType!("ktra");
		const __keyAEEditionFileLoc = getOSType!("eloc");
		const __keyAEElements = getOSType!("elms");
		const __keyAEEndPoint = getOSType!("pend");
		const __keyAEEventClass = getOSType!("evcl");
		const __keyAEEventID = getOSType!("evti");
		const __keyAEFile = getOSType!("kfil");
		const __keyAEFileType = getOSType!("fltp");
		const __keyAEFillColor = getOSType!("flcl");
		const __keyAEFillPattern = getOSType!("flpt");
		const __keyAEFlipHorizontal = getOSType!("kfho");
		const __keyAEFlipVertical = getOSType!("kfvt");
		const __keyAEFont = getOSType!("font");
		const __keyAEFormula = getOSType!("pfor");
		const __keyAEGraphicObjects = getOSType!("gobs");
		const __keyAEID = getOSType!("ID  ");
		const __keyAEImageQuality = getOSType!("gqua");
		const __keyAEInsertHere = getOSType!("insh");
		const __keyAEKeyForms = getOSType!("keyf");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __keyAEKeyword = getOSType!("kywd");
		const __keyAELevel = getOSType!("levl");
		const __keyAELineArrow = getOSType!("arro");
		const __keyAEName = getOSType!("pnam");
		const __keyAENewElementLoc = getOSType!("pnel");
		const __keyAEObject = getOSType!("kobj");
		const __keyAEObjectClass = getOSType!("kocl");
		const __keyAEOffStyles = getOSType!("ofst");
		const __keyAEOnStyles = getOSType!("onst");
		const __keyAEParameters = getOSType!("prms");
		const __keyAEParamFlags = getOSType!("pmfg");
		const __keyAEPenColor = getOSType!("ppcl");
		const __keyAEPenPattern = getOSType!("pppa");
		const __keyAEPenWidth = getOSType!("ppwd");
		const __keyAEPixelDepth = getOSType!("pdpt");
		const __keyAEPixMapMinus = getOSType!("kpmm");
		const __keyAEPMTable = getOSType!("kpmt");
		const __keyAEPointList = getOSType!("ptlt");
		const __keyAEPointSize = getOSType!("ptsz");
		const __keyAEPosition = getOSType!("kpos");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __keyAEPropData = getOSType!("prdt");
		const __keyAEProperties = getOSType!("qpro");
		const __keyAEProperty = getOSType!("kprp");
		const __keyAEPropFlags = getOSType!("prfg");
		const __keyAEPropID = getOSType!("prop");
		const __keyAEProtection = getOSType!("ppro");
		const __keyAERenderAs = getOSType!("kren");
		const __keyAERequestedType = getOSType!("rtyp");
		const __keyAEResult = getOSType!("----");
		const __keyAEResultInfo = getOSType!("rsin");
		const __keyAERotation = getOSType!("prot");
		const __keyAERotPoint = getOSType!("krtp");
		const __keyAERowList = getOSType!("krls");
		const __keyAESaveOptions = getOSType!("savo");
		const __keyAEScale = getOSType!("pscl");
		const __keyAEScriptTag = getOSType!("psct");
		const __keyAESearchText = getOSType!("stxt");
		const __keyAEShowWhere = getOSType!("show");
		const __keyAEStartAngle = getOSType!("pang");
		const __keyAEStartPoint = getOSType!("pstp");
		const __keyAEStyles = getOSType!("ksty");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __keyAESuiteID = getOSType!("suit");
		const __keyAEText = getOSType!("ktxt");
		const __keyAETextColor = getOSType!("ptxc");
		const __keyAETextFont = getOSType!("ptxf");
		const __keyAETextPointSize = getOSType!("ptps");
		const __keyAETextStyles = getOSType!("txst");
		const __keyAETextLineHeight = getOSType!("ktlh");
		const __keyAETextLineAscent = getOSType!("ktas");
		const __keyAETheText = getOSType!("thtx");
		const __keyAETransferMode = getOSType!("pptm");
		const __keyAETranslation = getOSType!("ptrs");
		const __keyAETryAsStructGraf = getOSType!("toog");
		const __keyAEUniformStyles = getOSType!("ustl");
		const __keyAEUpdateOn = getOSType!("pupd");
		const __keyAEUserTerm = getOSType!("utrm");
		const __keyAEWindow = getOSType!("wndw");
		const __keyAEWritingCode = getOSType!("wrcd");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __keyMiscellaneous = getOSType!("fmsc");
		const __keySelection = getOSType!("fsel");
		const __keyWindow = getOSType!("kwnd");
		const __keyWhen = getOSType!("when");
		const __keyWhere = getOSType!("wher");
		const __keyModifiers = getOSType!("mods");
		const __keyKey = getOSType!("key ");
		const __keyKeyCode = getOSType!("code");
		const __keyKeyboard = getOSType!("keyb");
		const __keyDriveNumber = getOSType!("drv#");
		const __keyErrorCode = getOSType!("err#");
		const __keyHighLevelClass = getOSType!("hcls");
		const __keyHighLevelID = getOSType!("hid ");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __pArcAngle = getOSType!("parc");
		const __pBackgroundColor = getOSType!("pbcl");
		const __pBackgroundPattern = getOSType!("pbpt");
		const __pBestType = getOSType!("pbst");
		const __pBounds = getOSType!("pbnd");
		const __pClass = getOSType!("pcls");
		const __pClipboard = getOSType!("pcli");
		const __pColor = getOSType!("colr");
		const __pColorTable = getOSType!("cltb");
		const __pContents = getOSType!("pcnt");
		const __pCornerCurveHeight = getOSType!("pchd");
		const __pCornerCurveWidth = getOSType!("pcwd");
		const __pDashStyle = getOSType!("pdst");
		const __pDefaultType = getOSType!("deft");
		const __pDefinitionRect = getOSType!("pdrt");
		const __pEnabled = getOSType!("enbl");
		const __pEndPoint = getOSType!("pend");
		const __pFillColor = getOSType!("flcl");
		const __pFillPattern = getOSType!("flpt");
		const __pFont = getOSType!("font");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __pFormula = getOSType!("pfor");
		const __pGraphicObjects = getOSType!("gobs");
		const __pHasCloseBox = getOSType!("hclb");
		const __pHasTitleBar = getOSType!("ptit");
		const __pID = getOSType!("ID  ");
		const __pIndex = getOSType!("pidx");
		const __pInsertionLoc = getOSType!("pins");
		const __pIsFloating = getOSType!("isfl");
		const __pIsFrontProcess = getOSType!("pisf");
		const __pIsModal = getOSType!("pmod");
		const __pIsModified = getOSType!("imod");
		const __pIsResizable = getOSType!("prsz");
		const __pIsStationeryPad = getOSType!("pspd");
		const __pIsZoomable = getOSType!("iszm");
		const __pIsZoomed = getOSType!("pzum");
		const __pItemNumber = getOSType!("itmn");
		const __pJustification = getOSType!("pjst");
		const __pLineArrow = getOSType!("arro");
		const __pMenuID = getOSType!("mnid");
		const __pName = getOSType!("pnam");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __pNewElementLoc = getOSType!("pnel");
		const __pPenColor = getOSType!("ppcl");
		const __pPenPattern = getOSType!("pppa");
		const __pPenWidth = getOSType!("ppwd");
		const __pPixelDepth = getOSType!("pdpt");
		const __pPointList = getOSType!("ptlt");
		const __pPointSize = getOSType!("ptsz");
		const __pProtection = getOSType!("ppro");
		const __pRotation = getOSType!("prot");
		const __pScale = getOSType!("pscl");
		const __pScript = getOSType!("scpt");
		const __pScriptTag = getOSType!("psct");
		const __pSelected = getOSType!("selc");
		const __pSelection = getOSType!("sele");
		const __pStartAngle = getOSType!("pang");
		const __pStartPoint = getOSType!("pstp");
		const __pTextColor = getOSType!("ptxc");
		const __pTextFont = getOSType!("ptxf");
		const __pTextItemDelimiters = getOSType!("txdl");
		const __pTextPointSize = getOSType!("ptps");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __pTextStyles = getOSType!("txst");
		const __pTransferMode = getOSType!("pptm");
		const __pTranslation = getOSType!("ptrs");
		const __pUniformStyles = getOSType!("ustl");
		const __pUpdateOn = getOSType!("pupd");
		const __pUserSelection = getOSType!("pusl");
		const __pVersion = getOSType!("vers");
		const __pVisible = getOSType!("pvis");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __typeAEText = getOSType!("tTXT");
		const __typeArc = getOSType!("carc");
		const __typeBest = getOSType!("best");
		const __typeCell = getOSType!("ccel");
		const __typeClassInfo = getOSType!("gcli");
		const __typeColorTable = getOSType!("clrt");
		const __typeColumn = getOSType!("ccol");
		const __typeDashStyle = getOSType!("tdas");
		const __typeData = getOSType!("tdta");
		const __typeDrawingArea = getOSType!("cdrw");
		const __typeElemInfo = getOSType!("elin");
		const __typeEnumeration = getOSType!("enum");
		const __typeEPS = getOSType!("EPS ");
		const __typeEventInfo = getOSType!("evin");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __typeFinderWindow = getOSType!("fwin");
		const __typeFixedPoint = getOSType!("fpnt");
		const __typeFixedRectangle = getOSType!("frct");
		const __typeGraphicLine = getOSType!("glin");
		const __typeGraphicText = getOSType!("cgtx");
		const __typeGroupedGraphic = getOSType!("cpic");
		const __typeInsertionLoc = getOSType!("insl");
		const __typeIntlText = getOSType!("itxt");
		const __typeIntlWritingCode = getOSType!("intl");
		const __typeLongDateTime = getOSType!("ldt ");
		const __typeCFAbsoluteTime = getOSType!("cfat");
		const __typeISO8601DateTime = getOSType!("isot");
		const __typeLongFixed = getOSType!("lfxd");
		const __typeLongFixedPoint = getOSType!("lfpt");
		const __typeLongFixedRectangle = getOSType!("lfrc");
		const __typeLongPoint = getOSType!("lpnt");
		const __typeLongRectangle = getOSType!("lrct");
		const __typeMachineLoc = getOSType!("mLoc");
		const __typeOval = getOSType!("covl");
		const __typeParamInfo = getOSType!("pmin");
		const __typePict = getOSType!("PICT");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __typePixelMap = getOSType!("cpix");
		const __typePixMapMinus = getOSType!("tpmm");
		const __typePolygon = getOSType!("cpgn");
		const __typePropInfo = getOSType!("pinf");
		const __typePtr = getOSType!("ptr ");
		const __typeQDPoint = getOSType!("QDpt");
		const __typeQDRegion = getOSType!("Qrgn");
		const __typeRectangle = getOSType!("crec");
		const __typeRGB16 = getOSType!("tr16");
		const __typeRGB96 = getOSType!("tr96");
		const __typeRGBColor = getOSType!("cRGB");
		const __typeRotation = getOSType!("trot");
		const __typeRoundedRectangle = getOSType!("crrc");
		const __typeRow = getOSType!("crow");
		const __typeScrapStyles = getOSType!("styl");
		const __typeScript = getOSType!("scpt");
		const __typeStyledText = getOSType!("STXT");
		const __typeSuiteInfo = getOSType!("suin");
		const __typeTable = getOSType!("ctbl");
		const __typeTextStyles = getOSType!("tsty");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __typeTIFF = getOSType!("TIFF");
		const __typeJPEG = getOSType!("JPEG");
		const __typeGIF = getOSType!("GIFf");
		const __typeVersion = getOSType!("vers");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kAEMenuClass = getOSType!("menu");
		const __kAEMenuSelect = getOSType!("mhit");
		const __kAEMouseDown = getOSType!("mdwn");
		const __kAEMouseDownInBack = getOSType!("mdbk");
		const __kAEKeyDown = getOSType!("kdwn");
		const __kAEResized = getOSType!("rsiz");
		const __kAEPromise = getOSType!("prom");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __keyMenuID = getOSType!("mid ");
		const __keyMenuItem = getOSType!("mitm");
		const __keyCloseAllWindows = getOSType!("caw ");
		const __keyOriginalBounds = getOSType!("obnd");
		const __keyNewBounds = getOSType!("nbnd");
		const __keyLocalWhere = getOSType!("lwhr");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __typeHIMenu = getOSType!("mobj");
		const __typeHIWindow = getOSType!("wobj");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kTextServiceClass = getOSType!("tsvc");
		const __kUpdateActiveInputArea = getOSType!("updt");
		const __kShowHideInputWindow = getOSType!("shiw");
		const __kPos2Offset = getOSType!("p2st");
		const __kOffset2Pos = getOSType!("st2p");
		const __kUnicodeNotFromInputMethod = getOSType!("unim");
		const __kGetSelectedText = getOSType!("gtxt");
		const __keyAETSMDocumentRefcon = getOSType!("refc");
		const __keyAEServerInstance = getOSType!("srvi");
		const __keyAETheData = getOSType!("kdat");
		const __keyAEFixLength = getOSType!("fixl");
		const __keyAEUpdateRange = getOSType!("udng");
		const __keyAECurrentPoint = getOSType!("cpos");
		const __keyAEBufferSize = getOSType!("buff");
		const __keyAEMoveView = getOSType!("mvvw");
		const __keyAENextBody = getOSType!("nxbd");
		const __keyAETSMScriptTag = getOSType!("sclg");
		const __keyAETSMTextFont = getOSType!("ktxf");
		const __keyAETSMTextFMFont = getOSType!("ktxm");
		const __keyAETSMTextPointSize = getOSType!("ktps");
		const __keyAETSMEventRecord = getOSType!("tevt");
		const __keyAETSMEventRef = getOSType!("tevr");
		const __keyAETextServiceEncoding = getOSType!("tsen");
		const __keyAETextServiceMacEncoding = getOSType!("tmen");
		const __keyAETSMGlyphInfoArray = getOSType!("tgia");
		const __typeTextRange = getOSType!("txrn");
		const __typeComponentInstance = getOSType!("cmpi");
		const __typeOffsetArray = getOSType!("ofay");
		const __typeTextRangeArray = getOSType!("tray");
		const __typeLowLevelEventRecord = getOSType!("evtr");
		const __typeGlyphInfoArray = getOSType!("glia");
		const __typeEventRef = getOSType!("evrf");
	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __keyAEHiliteRange = getOSType!("hrng");
		const __keyAEPinRange = getOSType!("pnrg");
		const __keyAEClauseOffsets = getOSType!("clau");
		const __keyAEOffset = getOSType!("ofst");
		const __keyAEPoint = getOSType!("gpos");
		const __keyAELeftSide = getOSType!("klef");
		const __keyAERegionClass = getOSType!("rgnc");
		const __keyAEDragging = getOSType!("bool");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __typeMeters = getOSType!("metr");
		const __typeInches = getOSType!("inch");
		const __typeFeet = getOSType!("feet");
		const __typeYards = getOSType!("yard");
		const __typeMiles = getOSType!("mile");
		const __typeKilometers = getOSType!("kmtr");
		const __typeCentimeters = getOSType!("cmtr");
		const __typeSquareMeters = getOSType!("sqrm");
		const __typeSquareFeet = getOSType!("sqft");
		const __typeSquareYards = getOSType!("sqyd");
		const __typeSquareMiles = getOSType!("sqmi");
		const __typeSquareKilometers = getOSType!("sqkm");
		const __typeLiters = getOSType!("litr");
		const __typeQuarts = getOSType!("qrts");
		const __typeGallons = getOSType!("galn");
		const __typeCubicMeters = getOSType!("cmet");
		const __typeCubicFeet = getOSType!("cfet");
		const __typeCubicInches = getOSType!("cuin");
		const __typeCubicCentimeter = getOSType!("ccmt");
		const __typeCubicYards = getOSType!("cyrd");
		const __typeKilograms = getOSType!("kgrm");
		const __typeGrams = getOSType!("gram");
		const __typeOunces = getOSType!("ozs ");
		const __typePounds = getOSType!("lbs ");
		const __typeDegreesC = getOSType!("degc");
		const __typeDegreesF = getOSType!("degf");
		const __typeDegreesK = getOSType!("degk");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kFAServerApp = getOSType!("ssrv");
		const __kDoFolderActionEvent = getOSType!("fola");
		const __kFolderActionCode = getOSType!("actn");
		const __kFolderOpenedEvent = getOSType!("fopn");
		const __kFolderClosedEvent = getOSType!("fclo");
		const __kFolderWindowMovedEvent = getOSType!("fsiz");
		const __kFolderItemsAddedEvent = getOSType!("fget");
		const __kFolderItemsRemovedEvent = getOSType!("flos");
		const __kItemList = getOSType!("flst");
		const __kNewSizeParameter = getOSType!("fnsz");
		const __kFASuiteCode = getOSType!("faco");
		const __kFAAttachCommand = getOSType!("atfa");
		const __kFARemoveCommand = getOSType!("rmfa");
		const __kFAEditCommand = getOSType!("edfa");
		const __kFAFileParam = getOSType!("faal");
		const __kFAIndexParam = getOSType!("indx");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kAEInternetSuite = getOSType!("gurl");
	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kAEISGetURL = getOSType!("gurl");
		const __KAEISHandleCGI = getOSType!("sdoc");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __cURL = getOSType!("url ");
		const __cInternetAddress = getOSType!("IPAD");
		const __cHTML = getOSType!("html");
		const __cFTPItem = getOSType!("ftp ");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kAEISHTTPSearchArgs = getOSType!("kfor");
		const __kAEISPostArgs = getOSType!("post");
		const __kAEISMethod = getOSType!("meth");
		const __kAEISClientAddress = getOSType!("addr");
		const __kAEISUserName = getOSType!("user");
		const __kAEISPassword = getOSType!("pass");
		const __kAEISFromUser = getOSType!("frmu");
		const __kAEISServerName = getOSType!("svnm");
		const __kAEISServerPort = getOSType!("svpt");
		const __kAEISScriptName = getOSType!("scnm");
		const __kAEISContentType = getOSType!("ctyp");
		const __kAEISReferrer = getOSType!("refr");
		const __kAEISUserAgent = getOSType!("Agnt");
		const __kAEISAction = getOSType!("Kact");
		const __kAEISActionPath = getOSType!("Kapt");
		const __kAEISClientIP = getOSType!("Kcip");
		const __kAEISFullRequest = getOSType!("Kfrq");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __pScheme = getOSType!("pusc");
		const __pHost = getOSType!("HOST");
		const __pPath = getOSType!("FTPc");
		const __pUserName = getOSType!("RAun");
		const __pUserPassword = getOSType!("RApw");
		const __pDNSForm = getOSType!("pDNS");
		const __pURL = getOSType!("pURL");
		const __pTextEncoding = getOSType!("ptxe");
		const __pFTPKind = getOSType!("kind");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __eScheme = getOSType!("esch");
		const __eurlHTTP = getOSType!("http");
		const __eurlHTTPS = getOSType!("htps");
		const __eurlFTP = getOSType!("ftp ");
		const __eurlMail = getOSType!("mail");
		const __eurlFile = getOSType!("file");
		const __eurlGopher = getOSType!("gphr");
		const __eurlTelnet = getOSType!("tlnt");
		const __eurlNews = getOSType!("news");
		const __eurlSNews = getOSType!("snws");
		const __eurlNNTP = getOSType!("nntp");
		const __eurlMessage = getOSType!("mess");
		const __eurlMailbox = getOSType!("mbox");
		const __eurlMulti = getOSType!("mult");
		const __eurlLaunch = getOSType!("laun");
		const __eurlAFP = getOSType!("afp ");
		const __eurlAT = getOSType!("at  ");
		const __eurlEPPC = getOSType!("eppc");
		const __eurlRTSP = getOSType!("rtsp");
		const __eurlIMAP = getOSType!("imap");
		const __eurlNFS = getOSType!("unfs");
		const __eurlPOP = getOSType!("upop");
		const __eurlLDAP = getOSType!("uldp");
		const __eurlUnknown = getOSType!("url?");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kConnSuite = getOSType!("macc");
		const __cDevSpec = getOSType!("cdev");
		const __cAddressSpec = getOSType!("cadr");
		const __cADBAddress = getOSType!("cadb");
		const __cAppleTalkAddress = getOSType!("cat ");
		const __cBusAddress = getOSType!("cbus");
		const __cEthernetAddress = getOSType!("cen ");
		const __cFireWireAddress = getOSType!("cfw ");
		const __cIPAddress = getOSType!("cip ");
		const __cLocalTalkAddress = getOSType!("clt ");
		const __cSCSIAddress = getOSType!("cscs");
		const __cTokenRingAddress = getOSType!("ctok");
		const __cUSBAddress = getOSType!("cusb");
		const __pDeviceType = getOSType!("pdvt");
		const __pDeviceAddress = getOSType!("pdva");
		const __pConduit = getOSType!("pcon");
		const __pProtocol = getOSType!("pprt");
		const __pATMachine = getOSType!("patm");
		const __pATZone = getOSType!("patz");
		const __pATType = getOSType!("patt");
		const __pDottedDecimal = getOSType!("pipd");
		const __pDNS = getOSType!("pdns");
		const __pPort = getOSType!("ppor");
		const __pNetwork = getOSType!("pnet");
		const __pNode = getOSType!("pnod");
		const __pSocket = getOSType!("psoc");
		const __pSCSIBus = getOSType!("pscb");
		const __pSCSILUN = getOSType!("pslu");
		const __eDeviceType = getOSType!("edvt");
		const __eAddressSpec = getOSType!("eads");
		const __eConduit = getOSType!("econ");
		const __eProtocol = getOSType!("epro");
		const __eADB = getOSType!("eadb");
		const __eAnalogAudio = getOSType!("epau");
		const __eAppleTalk = getOSType!("epat");
		const __eAudioLineIn = getOSType!("ecai");
		const __eAudioLineOut = getOSType!("ecal");
		const __eAudioOut = getOSType!("ecao");
		const __eBus = getOSType!("ebus");
		const __eCDROM = getOSType!("ecd ");
		const __eCommSlot = getOSType!("eccm");
		const __eDigitalAudio = getOSType!("epda");
		const __eDisplay = getOSType!("edds");
		const __eDVD = getOSType!("edvd");
		const __eEthernet = getOSType!("ecen");
		const __eFireWire = getOSType!("ecfw");
		const __eFloppy = getOSType!("efd ");
		const __eHD = getOSType!("ehd ");
		const __eInfrared = getOSType!("ecir");
		const __eIP = getOSType!("epip");
		const __eIrDA = getOSType!("epir");
		const __eIRTalk = getOSType!("epit");
		const __eKeyboard = getOSType!("ekbd");
		const __eLCD = getOSType!("edlc");
		const __eLocalTalk = getOSType!("eclt");
		const __eMacIP = getOSType!("epmi");
		const __eMacVideo = getOSType!("epmv");
		const __eMicrophone = getOSType!("ecmi");
		const __eModemPort = getOSType!("ecmp");
		const __eModemPrinterPort = getOSType!("empp");
		const __eModem = getOSType!("edmm");
		const __eMonitorOut = getOSType!("ecmn");
		const __eMouse = getOSType!("emou");
		const __eNuBusCard = getOSType!("ednb");
		const __eNuBus = getOSType!("enub");
		const __ePCcard = getOSType!("ecpc");
		const __ePCIbus = getOSType!("ecpi");
		const __ePCIcard = getOSType!("edpi");
		const __ePDSslot = getOSType!("ecpd");
		const __ePDScard = getOSType!("epds");
		const __ePointingDevice = getOSType!("edpd");
		const __ePostScript = getOSType!("epps");
		const __ePPP = getOSType!("eppp");
		const __ePrinterPort = getOSType!("ecpp");
		const __ePrinter = getOSType!("edpr");
		const __eSvideo = getOSType!("epsv");
		const __eSCSI = getOSType!("ecsc");
		const __eSerial = getOSType!("epsr");
		const __eSpeakers = getOSType!("edsp");
		const __eStorageDevice = getOSType!("edst");
		const __eSVGA = getOSType!("epsg");
		const __eTokenRing = getOSType!("etok");
		const __eTrackball = getOSType!("etrk");
		const __eTrackpad = getOSType!("edtp");
		const __eUSB = getOSType!("ecus");
		const __eVideoIn = getOSType!("ecvi");
		const __eVideoMonitor = getOSType!("edvm");
		const __eVideoOut = getOSType!("ecvo");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __cKeystroke = getOSType!("kprs");
		const __pKeystrokeKey = getOSType!("kMsg");
		const __pModifiers = getOSType!("kMod");
		const __pKeyKind = getOSType!("kknd");
		const __eModifiers = getOSType!("eMds");
		const __eOptionDown = getOSType!("Kopt");
		const __eCommandDown = getOSType!("Kcmd");
		const __eControlDown = getOSType!("Kctl");
		const __eShiftDown = getOSType!("Ksft");
		const __eCapsLockDown = getOSType!("Kclk");
		const __eKeyKind = getOSType!("ekst");

	}
}

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __keyAELaunchedAsLogInItem = getOSType!("lgit");
		const __keyAELaunchedAsServiceItem = getOSType!("svit");

	}
}

enum
{
	cAEList = getOSType!("list"),
	cApplication = getOSType!("capp"),
	cArc = getOSType!("carc"),
	cBoolean = getOSType!("bool"),
	cCell = getOSType!("ccel"),
	cChar = getOSType!("cha "),
	cColorTable = getOSType!("clrt"),
	cColumn = getOSType!("ccol"),
	cDocument = getOSType!("docu"),
	cDrawingArea = getOSType!("cdrw"),
	cEnumeration = getOSType!("enum"),
	cFile = getOSType!("file"),
	cFixed = getOSType!("fixd"),
	cFixedPoint = getOSType!("fpnt"),
	cFixedRectangle = getOSType!("frct"),
	cGraphicLine = getOSType!("glin"),
	cGraphicObject = getOSType!("cgob"),
	cGraphicShape = getOSType!("cgsh"),
	cGraphicText = getOSType!("cgtx"),
	cGroupedGraphic = getOSType!("cpic")
}

enum
{
	cInsertionLoc = getOSType!("insl"),
	cInsertionPoint = getOSType!("cins"),
	cIntlText = getOSType!("itxt"),
	cIntlWritingCode = getOSType!("intl"),
	cItem = getOSType!("citm"),
	cLine = getOSType!("clin"),
	cLongDateTime = getOSType!("ldt "),
	cLongFixed = getOSType!("lfxd"),
	cLongFixedPoint = getOSType!("lfpt"),
	cLongFixedRectangle = getOSType!("lfrc"),
	cLongInteger = getOSType!("long"),
	cLongPoint = getOSType!("lpnt"),
	cLongRectangle = getOSType!("lrct"),
	cMachineLoc = getOSType!("mLoc"),
	cMenu = getOSType!("cmnu"),
	cMenuItem = getOSType!("cmen"),
	cObject = getOSType!("cobj"),
	cObjectSpecifier = getOSType!("obj "),
	cOpenableObject = getOSType!("coob"),
	cOval = getOSType!("covl")
}

enum
{
	cParagraph = getOSType!("cpar"),
	cPICT = getOSType!("PICT"),
	cPixel = getOSType!("cpxl"),
	cPixelMap = getOSType!("cpix"),
	cPolygon = getOSType!("cpgn"),
	cProperty = getOSType!("prop"),
	cQDPoint = getOSType!("QDpt"),
	cQDRectangle = getOSType!("qdrt"),
	cRectangle = getOSType!("crec"),
	cRGBColor = getOSType!("cRGB"),
	cRotation = getOSType!("trot"),
	cRoundedRectangle = getOSType!("crrc"),
	cRow = getOSType!("crow"),
	cSelection = getOSType!("csel"),
	cShortInteger = getOSType!("shor"),
	cTable = getOSType!("ctbl"),
	cText = getOSType!("ctxt"),
	cTextFlow = getOSType!("cflo"),
	cTextStyles = getOSType!("tsty"),
	cType = getOSType!("type")
}

enum
{
	cVersion = getOSType!("vers"),
	cWindow = getOSType!("cwin"),
	cWord = getOSType!("cwor"),
	enumArrows = getOSType!("arro"),
	enumJustification = getOSType!("just"),
	enumKeyForm = getOSType!("kfrm"),
	enumPosition = getOSType!("posi"),
	enumProtection = getOSType!("prtn"),
	enumQuality = getOSType!("qual"),
	enumSaveOptions = getOSType!("savo"),
	enumStyle = getOSType!("styl"),
	enumTransferMode = getOSType!("tran"),
	kAEAbout = getOSType!("abou"),
	kAEAfter = getOSType!("afte"),
	kAEAliasSelection = getOSType!("sali"),
	kAEAllCaps = getOSType!("alcp"),
	kAEArrowAtEnd = getOSType!("aren"),
	kAEArrowAtStart = getOSType!("arst"),
	kAEArrowBothEnds = getOSType!("arbo")
}

enum
{
	kAEAsk = getOSType!("ask "),
	kAEBefore = getOSType!("befo"),
	kAEBeginning = getOSType!("bgng"),
	kAEBeginsWith = getOSType!("bgwt"),
	kAEBeginTransaction = getOSType!("begi"),
	kAEBold = getOSType!("bold"),
	kAECaseSensEquals = getOSType!("cseq"),
	kAECentered = getOSType!("cent"),
	kAEChangeView = getOSType!("view"),
	kAEClone = getOSType!("clon"),
	kAEClose = getOSType!("clos"),
	kAECondensed = getOSType!("cond"),
	kAEContains = getOSType!("cont"),
	kAECopy = getOSType!("copy"),
	kAECoreSuite = getOSType!("core"),
	kAECountElements = getOSType!("cnte"),
	kAECreateElement = getOSType!("crel"),
	kAECreatePublisher = getOSType!("cpub"),
	kAECut = getOSType!("cut "),
	kAEDelete = getOSType!("delo")
}

enum
{
	kAEDoObjectsExist = getOSType!("doex"),
	kAEDoScript = getOSType!("dosc"),
	kAEDrag = getOSType!("drag"),
	kAEDuplicateSelection = getOSType!("sdup"),
	kAEEditGraphic = getOSType!("edit"),
	kAEEmptyTrash = getOSType!("empt"),
	kAEEnd = getOSType!("end "),
	kAEEndsWith = getOSType!("ends"),
	kAEEndTransaction = getOSType!("endt"),
	kAEEquals = getOSType!("=   "),
	kAEExpanded = getOSType!("pexp"),
	kAEFast = getOSType!("fast"),
	kAEFinderEvents = getOSType!("FNDR"),
	kAEFormulaProtect = getOSType!("fpro"),
	kAEFullyJustified = getOSType!("full"),
	kAEGetClassInfo = getOSType!("qobj"),
	kAEGetData = getOSType!("getd"),
	kAEGetDataSize = getOSType!("dsiz"),
	kAEGetEventInfo = getOSType!("gtei"),
	kAEGetInfoSelection = getOSType!("sinf")
}

enum
{
	kAEGetPrivilegeSelection = getOSType!("sprv"),
	kAEGetSuiteInfo = getOSType!("gtsi"),
	kAEGreaterThan = getOSType!(">   "),
	kAEGreaterThanEquals = getOSType!(">=  "),
	kAEGrow = getOSType!("grow"),
	kAEHidden = getOSType!("hidn"),
	kAEHiQuality = getOSType!("hiqu"),
	kAEImageGraphic = getOSType!("imgr"),
	kAEIsUniform = getOSType!("isun"),
	kAEItalic = getOSType!("ital"),
	kAELeftJustified = getOSType!("left"),
	kAELessThan = getOSType!("<   "),
	kAELessThanEquals = getOSType!("<=  "),
	kAELowercase = getOSType!("lowc"),
	kAEMakeObjectsVisible = getOSType!("mvis"),
	kAEMiscStandards = getOSType!("misc"),
	kAEModifiable = getOSType!("modf"),
	kAEMove = getOSType!("move"),
	kAENo = getOSType!("no  "),
	kAENoArrow = getOSType!("arno")
}

enum
{
	kAENonmodifiable = getOSType!("nmod"),
	kAEOpen = getOSType!("odoc"),
	kAEOpenSelection = getOSType!("sope"),
	kAEOutline = getOSType!("outl"),
	kAEPageSetup = getOSType!("pgsu"),
	kAEPaste = getOSType!("past"),
	kAEPlain = getOSType!("plan"),
	kAEPrint = getOSType!("pdoc"),
	kAEPrintSelection = getOSType!("spri"),
	kAEPrintWindow = getOSType!("pwin"),
	kAEPutAwaySelection = getOSType!("sput"),
	kAEQDAddOver = getOSType!("addo"),
	kAEQDAddPin = getOSType!("addp"),
	kAEQDAdMax = getOSType!("admx"),
	kAEQDAdMin = getOSType!("admn"),
	kAEQDBic = getOSType!("bic "),
	kAEQDBlend = getOSType!("blnd"),
	kAEQDCopy = getOSType!("cpy "),
	kAEQDNotBic = getOSType!("nbic"),
	kAEQDNotCopy = getOSType!("ncpy")
}

enum
{
	kAEQDNotOr = getOSType!("ntor"),
	kAEQDNotXor = getOSType!("nxor"),
	kAEQDOr = getOSType!("or  "),
	kAEQDSubOver = getOSType!("subo"),
	kAEQDSubPin = getOSType!("subp"),
	kAEQDSupplementalSuite = getOSType!("qdsp"),
	kAEQDXor = getOSType!("xor "),
	kAEQuickdrawSuite = getOSType!("qdrw"),
	kAEQuitAll = getOSType!("quia"),
	kAERedo = getOSType!("redo"),
	kAERegular = getOSType!("regl"),
	kAEReopenApplication = getOSType!("rapp"),
	kAEReplace = getOSType!("rplc"),
	kAERequiredSuite = getOSType!("reqd"),
	kAERestart = getOSType!("rest"),
	kAERevealSelection = getOSType!("srev"),
	kAERevert = getOSType!("rvrt"),
	kAERightJustified = getOSType!("rght"),
	kAESave = getOSType!("save"),
	kAESelect = getOSType!("slct"),
	kAESetData = getOSType!("setd")
}

enum
{
	kAESetPosition = getOSType!("posn"),
	kAEShadow = getOSType!("shad"),
	kAEShowClipboard = getOSType!("shcl"),
	kAEShutDown = getOSType!("shut"),
	kAESleep = getOSType!("slep"),
	kAESmallCaps = getOSType!("smcp"),
	kAESpecialClassProperties = getOSType!("c@#!"),
	kAEStrikethrough = getOSType!("strk"),
	kAESubscript = getOSType!("sbsc"),
	kAESuperscript = getOSType!("spsc"),
	kAETableSuite = getOSType!("tbls"),
	kAETextSuite = getOSType!("TEXT"),
	kAETransactionTerminated = getOSType!("ttrm"),
	kAEUnderline = getOSType!("undl"),
	kAEUndo = getOSType!("undo"),
	kAEWholeWordEquals = getOSType!("wweq"),
	kAEYes = getOSType!("yes "),
	kAEZoom = getOSType!("zoom")
}

enum
{
	kAELogOut = getOSType!("logo"),
	kAEReallyLogOut = getOSType!("rlgo"),
	kAEShowRestartDialog = getOSType!("rrst"),
	kAEShowShutdownDialog = getOSType!("rsdn")
}

enum
{
	kAEMouseClass = getOSType!("mous"),
	kAEDown = getOSType!("down"),
	kAEUp = getOSType!("up  "),
	kAEMoved = getOSType!("move"),
	kAEStoppedMoving = getOSType!("stop"),
	kAEWindowClass = getOSType!("wind"),
	kAEUpdate = getOSType!("updt"),
	kAEActivate = getOSType!("actv"),
	kAEDeactivate = getOSType!("dact"),
	kAECommandClass = getOSType!("cmnd"),
	kAEKeyClass = getOSType!("keyc"),
	kAERawKey = getOSType!("rkey"),
	kAEVirtualKey = getOSType!("keyc"),
	kAENavigationKey = getOSType!("nave"),
	kAEAutoDown = getOSType!("auto"),
	kAEApplicationClass = getOSType!("appl"),
	kAESuspend = getOSType!("susp"),
	kAEResume = getOSType!("rsme"),
	kAEDiskEvent = getOSType!("disk"),
	kAENullEvent = getOSType!("null"),
	kAEWakeUpEvent = getOSType!("wake"),
	kAEScrapEvent = getOSType!("scrp"),
	kAEHighLevel = getOSType!("high")
}

enum
{
	keyAEAngle = getOSType!("kang"),
	keyAEArcAngle = getOSType!("parc")
}

enum
{
	keyAEBaseAddr = getOSType!("badd"),
	keyAEBestType = getOSType!("pbst"),
	keyAEBgndColor = getOSType!("kbcl"),
	keyAEBgndPattern = getOSType!("kbpt"),
	keyAEBounds = getOSType!("pbnd"),
	keyAECellList = getOSType!("kclt"),
	keyAEClassID = getOSType!("clID"),
	keyAEColor = getOSType!("colr"),
	keyAEColorTable = getOSType!("cltb"),
	keyAECurveHeight = getOSType!("kchd"),
	keyAECurveWidth = getOSType!("kcwd"),
	keyAEDashStyle = getOSType!("pdst"),
	keyAEData = getOSType!("data"),
	keyAEDefaultType = getOSType!("deft"),
	keyAEDefinitionRect = getOSType!("pdrt"),
	keyAEDescType = getOSType!("dstp"),
	keyAEDestination = getOSType!("dest"),
	keyAEDoAntiAlias = getOSType!("anta"),
	keyAEDoDithered = getOSType!("gdit"),
	keyAEDoRotate = getOSType!("kdrt")
}

enum
{
	keyAEDoScale = getOSType!("ksca"),
	keyAEDoTranslate = getOSType!("ktra"),
	keyAEEditionFileLoc = getOSType!("eloc"),
	keyAEElements = getOSType!("elms"),
	keyAEEndPoint = getOSType!("pend"),
	keyAEEventClass = getOSType!("evcl"),
	keyAEEventID = getOSType!("evti"),
	keyAEFile = getOSType!("kfil"),
	keyAEFileType = getOSType!("fltp"),
	keyAEFillColor = getOSType!("flcl"),
	keyAEFillPattern = getOSType!("flpt"),
	keyAEFlipHorizontal = getOSType!("kfho"),
	keyAEFlipVertical = getOSType!("kfvt"),
	keyAEFont = getOSType!("font"),
	keyAEFormula = getOSType!("pfor"),
	keyAEGraphicObjects = getOSType!("gobs"),
	keyAEID = getOSType!("ID  "),
	keyAEImageQuality = getOSType!("gqua"),
	keyAEInsertHere = getOSType!("insh"),
	keyAEKeyForms = getOSType!("keyf")
}

enum
{
	keyAEKeyword = getOSType!("kywd"),
	keyAELevel = getOSType!("levl"),
	keyAELineArrow = getOSType!("arro"),
	keyAEName = getOSType!("pnam"),
	keyAENewElementLoc = getOSType!("pnel"),
	keyAEObject = getOSType!("kobj"),
	keyAEObjectClass = getOSType!("kocl"),
	keyAEOffStyles = getOSType!("ofst"),
	keyAEOnStyles = getOSType!("onst"),
	keyAEParameters = getOSType!("prms"),
	keyAEParamFlags = getOSType!("pmfg"),
	keyAEPenColor = getOSType!("ppcl"),
	keyAEPenPattern = getOSType!("pppa"),
	keyAEPenWidth = getOSType!("ppwd"),
	keyAEPixelDepth = getOSType!("pdpt"),
	keyAEPixMapMinus = getOSType!("kpmm"),
	keyAEPMTable = getOSType!("kpmt"),
	keyAEPointList = getOSType!("ptlt"),
	keyAEPointSize = getOSType!("ptsz"),
	keyAEPosition = getOSType!("kpos")
}

enum
{
	keyAEPropData = getOSType!("prdt"),
	keyAEProperties = getOSType!("qpro"),
	keyAEProperty = getOSType!("kprp"),
	keyAEPropFlags = getOSType!("prfg"),
	keyAEPropID = getOSType!("prop"),
	keyAEProtection = getOSType!("ppro"),
	keyAERenderAs = getOSType!("kren"),
	keyAERequestedType = getOSType!("rtyp"),
	keyAEResult = getOSType!("----"),
	keyAEResultInfo = getOSType!("rsin"),
	keyAERotation = getOSType!("prot"),
	keyAERotPoint = getOSType!("krtp"),
	keyAERowList = getOSType!("krls"),
	keyAESaveOptions = getOSType!("savo"),
	keyAEScale = getOSType!("pscl"),
	keyAEScriptTag = getOSType!("psct"),
	keyAESearchText = getOSType!("stxt"),
	keyAEShowWhere = getOSType!("show"),
	keyAEStartAngle = getOSType!("pang"),
	keyAEStartPoint = getOSType!("pstp"),
	keyAEStyles = getOSType!("ksty")
}

enum
{
	keyAESuiteID = getOSType!("suit"),
	keyAEText = getOSType!("ktxt"),
	keyAETextColor = getOSType!("ptxc"),
	keyAETextFont = getOSType!("ptxf"),
	keyAETextPointSize = getOSType!("ptps"),
	keyAETextStyles = getOSType!("txst"),
	keyAETextLineHeight = getOSType!("ktlh"),
	keyAETextLineAscent = getOSType!("ktas"),
	keyAETheText = getOSType!("thtx"),
	keyAETransferMode = getOSType!("pptm"),
	keyAETranslation = getOSType!("ptrs"),
	keyAETryAsStructGraf = getOSType!("toog"),
	keyAEUniformStyles = getOSType!("ustl"),
	keyAEUpdateOn = getOSType!("pupd"),
	keyAEUserTerm = getOSType!("utrm"),
	keyAEWindow = getOSType!("wndw"),
	keyAEWritingCode = getOSType!("wrcd")
}

enum
{
	keyMiscellaneous = getOSType!("fmsc"),
	keySelection = getOSType!("fsel"),
	keyWindow = getOSType!("kwnd"),
	keyWhen = getOSType!("when"),
	keyWhere = getOSType!("wher"),
	keyModifiers = getOSType!("mods"),
	keyKey = getOSType!("key "),
	keyKeyCode = getOSType!("code"),
	keyKeyboard = getOSType!("keyb"),
	keyDriveNumber = getOSType!("drv#"),
	keyErrorCode = getOSType!("err#"),
	keyHighLevelClass = getOSType!("hcls"),
	keyHighLevelID = getOSType!("hid ")
}

enum
{
	pArcAngle = getOSType!("parc"),
	pBackgroundColor = getOSType!("pbcl"),
	pBackgroundPattern = getOSType!("pbpt"),
	pBestType = getOSType!("pbst"),
	pBounds = getOSType!("pbnd"),
	pClass = getOSType!("pcls"),
	pClipboard = getOSType!("pcli"),
	pColor = getOSType!("colr"),
	pColorTable = getOSType!("cltb"),
	pContents = getOSType!("pcnt"),
	pCornerCurveHeight = getOSType!("pchd"),
	pCornerCurveWidth = getOSType!("pcwd"),
	pDashStyle = getOSType!("pdst"),
	pDefaultType = getOSType!("deft"),
	pDefinitionRect = getOSType!("pdrt"),
	pEnabled = getOSType!("enbl"),
	pEndPoint = getOSType!("pend"),
	pFillColor = getOSType!("flcl"),
	pFillPattern = getOSType!("flpt"),
	pFont = getOSType!("font")
}

enum
{
	pFormula = getOSType!("pfor"),
	pGraphicObjects = getOSType!("gobs"),
	pHasCloseBox = getOSType!("hclb"),
	pHasTitleBar = getOSType!("ptit"),
	pID = getOSType!("ID  "),
	pIndex = getOSType!("pidx"),
	pInsertionLoc = getOSType!("pins"),
	pIsFloating = getOSType!("isfl"),
	pIsFrontProcess = getOSType!("pisf"),
	pIsModal = getOSType!("pmod"),
	pIsModified = getOSType!("imod"),
	pIsResizable = getOSType!("prsz"),
	pIsStationeryPad = getOSType!("pspd"),
	pIsZoomable = getOSType!("iszm"),
	pIsZoomed = getOSType!("pzum"),
	pItemNumber = getOSType!("itmn"),
	pJustification = getOSType!("pjst"),
	pLineArrow = getOSType!("arro"),
	pMenuID = getOSType!("mnid"),
	pName = getOSType!("pnam")
}

enum
{
	pNewElementLoc = getOSType!("pnel"),
	pPenColor = getOSType!("ppcl"),
	pPenPattern = getOSType!("pppa"),
	pPenWidth = getOSType!("ppwd"),
	pPixelDepth = getOSType!("pdpt"),
	pPointList = getOSType!("ptlt"),
	pPointSize = getOSType!("ptsz"),
	pProtection = getOSType!("ppro"),
	pRotation = getOSType!("prot"),
	pScale = getOSType!("pscl"),
	pScript = getOSType!("scpt"),
	pScriptTag = getOSType!("psct"),
	pSelected = getOSType!("selc"),
	pSelection = getOSType!("sele"),
	pStartAngle = getOSType!("pang"),
	pStartPoint = getOSType!("pstp"),
	pTextColor = getOSType!("ptxc"),
	pTextFont = getOSType!("ptxf"),
	pTextItemDelimiters = getOSType!("txdl"),
	pTextPointSize = getOSType!("ptps")
}

enum
{
	pTextStyles = getOSType!("txst"),
	pTransferMode = getOSType!("pptm"),
	pTranslation = getOSType!("ptrs"),
	pUniformStyles = getOSType!("ustl"),
	pUpdateOn = getOSType!("pupd"),
	pUserSelection = getOSType!("pusl"),
	pVersion = getOSType!("vers"),
	pVisible = getOSType!("pvis")
}

enum
{
	typeAEText = getOSType!("tTXT"),
	typeArc = getOSType!("carc"),
	typeBest = getOSType!("best"),
	typeCell = getOSType!("ccel"),
	typeClassInfo = getOSType!("gcli"),
	typeColorTable = getOSType!("clrt"),
	typeColumn = getOSType!("ccol"),
	typeDashStyle = getOSType!("tdas"),
	typeData = getOSType!("tdta"),
	typeDrawingArea = getOSType!("cdrw"),
	typeElemInfo = getOSType!("elin"),
	typeEnumeration = getOSType!("enum"),
	typeEPS = getOSType!("EPS "),
	typeEventInfo = getOSType!("evin")
}

enum
{
	typeFinderWindow = getOSType!("fwin"),
	typeFixedPoint = getOSType!("fpnt"),
	typeFixedRectangle = getOSType!("frct"),
	typeGraphicLine = getOSType!("glin"),
	typeGraphicText = getOSType!("cgtx"),
	typeGroupedGraphic = getOSType!("cpic"),
	typeInsertionLoc = getOSType!("insl"),
	typeIntlText = getOSType!("itxt"),
	typeIntlWritingCode = getOSType!("intl"),
	typeLongDateTime = getOSType!("ldt "),
	typeCFAbsoluteTime = getOSType!("cfat"),
	typeISO8601DateTime = getOSType!("isot"),
	typeLongFixed = getOSType!("lfxd"),
	typeLongFixedPoint = getOSType!("lfpt"),
	typeLongFixedRectangle = getOSType!("lfrc"),
	typeLongPoint = getOSType!("lpnt"),
	typeLongRectangle = getOSType!("lrct"),
	typeMachineLoc = getOSType!("mLoc"),
	typeOval = getOSType!("covl"),
	typeParamInfo = getOSType!("pmin"),
	typePict = getOSType!("PICT")
}

enum
{
	typePixelMap = getOSType!("cpix"),
	typePixMapMinus = getOSType!("tpmm"),
	typePolygon = getOSType!("cpgn"),
	typePropInfo = getOSType!("pinf"),
	typePtr = getOSType!("ptr "),
	typeQDPoint = getOSType!("QDpt"),
	typeQDRegion = getOSType!("Qrgn"),
	typeRectangle = getOSType!("crec"),
	typeRGB16 = getOSType!("tr16"),
	typeRGB96 = getOSType!("tr96"),
	typeRGBColor = getOSType!("cRGB"),
	typeRotation = getOSType!("trot"),
	typeRoundedRectangle = getOSType!("crrc"),
	typeRow = getOSType!("crow"),
	typeScrapStyles = getOSType!("styl"),
	typeScript = getOSType!("scpt"),
	typeStyledText = getOSType!("STXT"),
	typeSuiteInfo = getOSType!("suin"),
	typeTable = getOSType!("ctbl"),
	typeTextStyles = getOSType!("tsty")
}

enum
{
	typeTIFF = getOSType!("TIFF"),
	typeJPEG = getOSType!("JPEG"),
	typeGIF = getOSType!("GIFf"),
	typeVersion = getOSType!("vers")
}

enum
{
	kAEMenuClass = getOSType!("menu"),
	kAEMenuSelect = getOSType!("mhit"),
	kAEMouseDown = getOSType!("mdwn"),
	kAEMouseDownInBack = getOSType!("mdbk"),
	kAEKeyDown = getOSType!("kdwn"),
	kAEResized = getOSType!("rsiz"),
	kAEPromise = getOSType!("prom")
}

enum
{
	keyMenuID = getOSType!("mid "),
	keyMenuItem = getOSType!("mitm"),
	keyCloseAllWindows = getOSType!("caw "),
	keyOriginalBounds = getOSType!("obnd"),
	keyNewBounds = getOSType!("nbnd"),
	keyLocalWhere = getOSType!("lwhr")
}

enum
{
	typeHIMenu = getOSType!("mobj"),
	typeHIWindow = getOSType!("wobj")
}

enum
{
	kBySmallIcon = 0,
	kByIconView = 1,
	kByNameView = 2,
	kByDateView = 3,
	kBySizeView = 4,
	kByKindView = 5,
	kByCommentView = 6,
	kByLabelView = 7,
	kByVersionView = 8
}

enum
{
	kAEInfo = 11,
	kAEMain = 0,
	kAESharing = 13
}

enum
{
	kAEZoomIn = 7,
	kAEZoomOut = 8
}

enum
{
	kTextServiceClass = getOSType!("tsvc"),
	kUpdateActiveInputArea = getOSType!("updt"),
	kShowHideInputWindow = getOSType!("shiw"),
	kPos2Offset = getOSType!("p2st"),
	kOffset2Pos = getOSType!("st2p"),
	kUnicodeNotFromInputMethod = getOSType!("unim"),
	kGetSelectedText = getOSType!("gtxt"),
	keyAETSMDocumentRefcon = getOSType!("refc"),
	keyAEServerInstance = getOSType!("srvi"),
	keyAETheData = getOSType!("kdat"),
	keyAEFixLength = getOSType!("fixl"),
	keyAEUpdateRange = getOSType!("udng"),
	keyAECurrentPoint = getOSType!("cpos"),
	keyAEBufferSize = getOSType!("buff"),
	keyAEMoveView = getOSType!("mvvw"),
	keyAENextBody = getOSType!("nxbd"),
	keyAETSMScriptTag = getOSType!("sclg"),
	keyAETSMTextFont = getOSType!("ktxf"),
	keyAETSMTextFMFont = getOSType!("ktxm"),
	keyAETSMTextPointSize = getOSType!("ktps"),
	keyAETSMEventRecord = getOSType!("tevt"),
	keyAETSMEventRef = getOSType!("tevr"),
	keyAETextServiceEncoding = getOSType!("tsen"),
	keyAETextServiceMacEncoding = getOSType!("tmen"),
	keyAETSMGlyphInfoArray = getOSType!("tgia"),
	typeTextRange = getOSType!("txrn"),
	typeComponentInstance = getOSType!("cmpi"),
	typeOffsetArray = getOSType!("ofay"),
	typeTextRangeArray = getOSType!("tray"),
	typeLowLevelEventRecord = getOSType!("evtr"),
	typeGlyphInfoArray = getOSType!("glia"),
	typeEventRef = getOSType!("evrf"),
	typeText = typeChar
}

enum
{
	kTSMOutsideOfBody = 1,
	kTSMInsideOfBody = 2,
	kTSMInsideOfActiveInputArea = 3
}

enum
{
	kNextBody = 1,
	kPreviousBody = 2
}

enum
{
	kTSMHiliteCaretPosition = 1,
	kTSMHiliteRawText = 2,
	kTSMHiliteSelectedRawText = 3,
	kTSMHiliteConvertedText = 4,
	kTSMHiliteSelectedConvertedText = 5,
	kTSMHiliteBlockFillText = 6,
	kTSMHiliteOutlineText = 7,
	kTSMHiliteSelectedText = 8,
	kTSMHiliteNoHilite = 9
}

enum
{
	keyAEHiliteRange = getOSType!("hrng"),
	keyAEPinRange = getOSType!("pnrg"),
	keyAEClauseOffsets = getOSType!("clau"),
	keyAEOffset = getOSType!("ofst"),
	keyAEPoint = getOSType!("gpos"),
	keyAELeftSide = getOSType!("klef"),
	keyAERegionClass = getOSType!("rgnc"),
	keyAEDragging = getOSType!("bool")
}

enum
{
	typeMeters = getOSType!("metr"),
	typeInches = getOSType!("inch"),
	typeFeet = getOSType!("feet"),
	typeYards = getOSType!("yard"),
	typeMiles = getOSType!("mile"),
	typeKilometers = getOSType!("kmtr"),
	typeCentimeters = getOSType!("cmtr"),
	typeSquareMeters = getOSType!("sqrm"),
	typeSquareFeet = getOSType!("sqft"),
	typeSquareYards = getOSType!("sqyd"),
	typeSquareMiles = getOSType!("sqmi"),
	typeSquareKilometers = getOSType!("sqkm"),
	typeLiters = getOSType!("litr"),
	typeQuarts = getOSType!("qrts"),
	typeGallons = getOSType!("galn"),
	typeCubicMeters = getOSType!("cmet"),
	typeCubicFeet = getOSType!("cfet"),
	typeCubicInches = getOSType!("cuin"),
	typeCubicCentimeter = getOSType!("ccmt"),
	typeCubicYards = getOSType!("cyrd"),
	typeKilograms = getOSType!("kgrm"),
	typeGrams = getOSType!("gram"),
	typeOunces = getOSType!("ozs "),
	typePounds = getOSType!("lbs "),
	typeDegreesC = getOSType!("degc"),
	typeDegreesF = getOSType!("degf"),
	typeDegreesK = getOSType!("degk")
}

enum
{
	kFAServerApp = getOSType!("ssrv"),
	kDoFolderActionEvent = getOSType!("fola"),
	kFolderActionCode = getOSType!("actn"),
	kFolderOpenedEvent = getOSType!("fopn"),
	kFolderClosedEvent = getOSType!("fclo"),
	kFolderWindowMovedEvent = getOSType!("fsiz"),
	kFolderItemsAddedEvent = getOSType!("fget"),
	kFolderItemsRemovedEvent = getOSType!("flos"),
	kItemList = getOSType!("flst"),
	kNewSizeParameter = getOSType!("fnsz"),
	kFASuiteCode = getOSType!("faco"),
	kFAAttachCommand = getOSType!("atfa"),
	kFARemoveCommand = getOSType!("rmfa"),
	kFAEditCommand = getOSType!("edfa"),
	kFAFileParam = getOSType!("faal"),
	kFAIndexParam = getOSType!("indx")
}

enum
{
	kAEInternetSuite = getOSType!("gurl"),
	kAEISWebStarSuite = 0x575757BD
}

enum
{
	kAEISGetURL = getOSType!("gurl"),
	KAEISHandleCGI = getOSType!("sdoc")
}

enum
{
	cURL = getOSType!("url "),
	cInternetAddress = getOSType!("IPAD"),
	cHTML = getOSType!("html"),
	cFTPItem = getOSType!("ftp ")
}

enum
{
	kAEISHTTPSearchArgs = getOSType!("kfor"),
	kAEISPostArgs = getOSType!("post"),
	kAEISMethod = getOSType!("meth"),
	kAEISClientAddress = getOSType!("addr"),
	kAEISUserName = getOSType!("user"),
	kAEISPassword = getOSType!("pass"),
	kAEISFromUser = getOSType!("frmu"),
	kAEISServerName = getOSType!("svnm"),
	kAEISServerPort = getOSType!("svpt"),
	kAEISScriptName = getOSType!("scnm"),
	kAEISContentType = getOSType!("ctyp"),
	kAEISReferrer = getOSType!("refr"),
	kAEISUserAgent = getOSType!("Agnt"),
	kAEISAction = getOSType!("Kact"),
	kAEISActionPath = getOSType!("Kapt"),
	kAEISClientIP = getOSType!("Kcip"),
	kAEISFullRequest = getOSType!("Kfrq")
}

enum
{
	pScheme = getOSType!("pusc"),
	pHost = getOSType!("HOST"),
	pPath = getOSType!("FTPc"),
	pUserName = getOSType!("RAun"),
	pUserPassword = getOSType!("RApw"),
	pDNSForm = getOSType!("pDNS"),
	pURL = getOSType!("pURL"),
	pTextEncoding = getOSType!("ptxe"),
	pFTPKind = getOSType!("kind")
}

enum
{
	eScheme = getOSType!("esch"),
	eurlHTTP = getOSType!("http"),
	eurlHTTPS = getOSType!("htps"),
	eurlFTP = getOSType!("ftp "),
	eurlMail = getOSType!("mail"),
	eurlFile = getOSType!("file"),
	eurlGopher = getOSType!("gphr"),
	eurlTelnet = getOSType!("tlnt"),
	eurlNews = getOSType!("news"),
	eurlSNews = getOSType!("snws"),
	eurlNNTP = getOSType!("nntp"),
	eurlMessage = getOSType!("mess"),
	eurlMailbox = getOSType!("mbox"),
	eurlMulti = getOSType!("mult"),
	eurlLaunch = getOSType!("laun"),
	eurlAFP = getOSType!("afp "),
	eurlAT = getOSType!("at  "),
	eurlEPPC = getOSType!("eppc"),
	eurlRTSP = getOSType!("rtsp"),
	eurlIMAP = getOSType!("imap"),
	eurlNFS = getOSType!("unfs"),
	eurlPOP = getOSType!("upop"),
	eurlLDAP = getOSType!("uldp"),
	eurlUnknown = getOSType!("url?")
}

enum
{
	kConnSuite = getOSType!("macc"),
	cDevSpec = getOSType!("cdev"),
	cAddressSpec = getOSType!("cadr"),
	cADBAddress = getOSType!("cadb"),
	cAppleTalkAddress = getOSType!("cat "),
	cBusAddress = getOSType!("cbus"),
	cEthernetAddress = getOSType!("cen "),
	cFireWireAddress = getOSType!("cfw "),
	cIPAddress = getOSType!("cip "),
	cLocalTalkAddress = getOSType!("clt "),
	cSCSIAddress = getOSType!("cscs"),
	cTokenRingAddress = getOSType!("ctok"),
	cUSBAddress = getOSType!("cusb"),
	pDeviceType = getOSType!("pdvt"),
	pDeviceAddress = getOSType!("pdva"),
	pConduit = getOSType!("pcon"),
	pProtocol = getOSType!("pprt"),
	pATMachine = getOSType!("patm"),
	pATZone = getOSType!("patz"),
	pATType = getOSType!("patt"),
	pDottedDecimal = getOSType!("pipd"),
	pDNS = getOSType!("pdns"),
	pPort = getOSType!("ppor"),
	pNetwork = getOSType!("pnet"),
	pNode = getOSType!("pnod"),
	pSocket = getOSType!("psoc"),
	pSCSIBus = getOSType!("pscb"),
	pSCSILUN = getOSType!("pslu"),
	eDeviceType = getOSType!("edvt"),
	eAddressSpec = getOSType!("eads"),
	eConduit = getOSType!("econ"),
	eProtocol = getOSType!("epro"),
	eADB = getOSType!("eadb"),
	eAnalogAudio = getOSType!("epau"),
	eAppleTalk = getOSType!("epat"),
	eAudioLineIn = getOSType!("ecai"),
	eAudioLineOut = getOSType!("ecal"),
	eAudioOut = getOSType!("ecao"),
	eBus = getOSType!("ebus"),
	eCDROM = getOSType!("ecd "),
	eCommSlot = getOSType!("eccm"),
	eDigitalAudio = getOSType!("epda"),
	eDisplay = getOSType!("edds"),
	eDVD = getOSType!("edvd"),
	eEthernet = getOSType!("ecen"),
	eFireWire = getOSType!("ecfw"),
	eFloppy = getOSType!("efd "),
	eHD = getOSType!("ehd "),
	eInfrared = getOSType!("ecir"),
	eIP = getOSType!("epip"),
	eIrDA = getOSType!("epir"),
	eIRTalk = getOSType!("epit"),
	eKeyboard = getOSType!("ekbd"),
	eLCD = getOSType!("edlc"),
	eLocalTalk = getOSType!("eclt"),
	eMacIP = getOSType!("epmi"),
	eMacVideo = getOSType!("epmv"),
	eMicrophone = getOSType!("ecmi"),
	eModemPort = getOSType!("ecmp"),
	eModemPrinterPort = getOSType!("empp"),
	eModem = getOSType!("edmm"),
	eMonitorOut = getOSType!("ecmn"),
	eMouse = getOSType!("emou"),
	eNuBusCard = getOSType!("ednb"),
	eNuBus = getOSType!("enub"),
	ePCcard = getOSType!("ecpc"),
	ePCIbus = getOSType!("ecpi"),
	ePCIcard = getOSType!("edpi"),
	ePDSslot = getOSType!("ecpd"),
	ePDScard = getOSType!("epds"),
	ePointingDevice = getOSType!("edpd"),
	ePostScript = getOSType!("epps"),
	ePPP = getOSType!("eppp"),
	ePrinterPort = getOSType!("ecpp"),
	ePrinter = getOSType!("edpr"),
	eSvideo = getOSType!("epsv"),
	eSCSI = getOSType!("ecsc"),
	eSerial = getOSType!("epsr"),
	eSpeakers = getOSType!("edsp"),
	eStorageDevice = getOSType!("edst"),
	eSVGA = getOSType!("epsg"),
	eTokenRing = getOSType!("etok"),
	eTrackball = getOSType!("etrk"),
	eTrackpad = getOSType!("edtp"),
	eUSB = getOSType!("ecus"),
	eVideoIn = getOSType!("ecvi"),
	eVideoMonitor = getOSType!("edvm"),
	eVideoOut = getOSType!("ecvo")
}

enum
{
	cKeystroke = getOSType!("kprs"),
	pKeystrokeKey = getOSType!("kMsg"),
	pModifiers = getOSType!("kMod"),
	pKeyKind = getOSType!("kknd"),
	eModifiers = getOSType!("eMds"),
	eOptionDown = getOSType!("Kopt"),
	eCommandDown = getOSType!("Kcmd"),
	eControlDown = getOSType!("Kctl"),
	eShiftDown = getOSType!("Ksft"),
	eCapsLockDown = getOSType!("Kclk"),
	eKeyKind = getOSType!("ekst"),
	eEscapeKey = 0x6B733500,
	eDeleteKey = 0x6B733300,
	eTabKey = 0x6B733000,
	eReturnKey = 0x6B732400,
	eClearKey = 0x6B734700,
	eEnterKey = 0x6B734C00,
	eUpArrowKey = 0x6B737E00,
	eDownArrowKey = 0x6B737D00,
	eLeftArrowKey = 0x6B737B00,
	eRightArrowKey = 0x6B737C00,
	eHelpKey = 0x6B737200,
	eHomeKey = 0x6B737300,
	ePageUpKey = 0x6B737400,
	ePageDownKey = 0x6B737900,
	eForwardDelKey = 0x6B737500,
	eEndKey = 0x6B737700,
	eF1Key = 0x6B737A00,
	eF2Key = 0x6B737800,
	eF3Key = 0x6B736300,
	eF4Key = 0x6B737600,
	eF5Key = 0x6B736000,
	eF6Key = 0x6B736100,
	eF7Key = 0x6B736200,
	eF8Key = 0x6B736400,
	eF9Key = 0x6B736500,
	eF10Key = 0x6B736D00,
	eF11Key = 0x6B736700,
	eF12Key = 0x6B736F00,
	eF13Key = 0x6B736900,
	eF14Key = 0x6B736B00,
	eF15Key = 0x6B737100
}

enum
{
	keyAELaunchedAsLogInItem = getOSType!("lgit"),
	keyAELaunchedAsServiceItem = getOSType!("svit")
}

struct TextRange
{
	int fStart;
	int fEnd;
	short fHiliteStyle;
}


struct TextRangeArray
{
	short fNumOfRanges;
	TextRange* fRange;
}


struct OffsetArray
{
	short fNumOfOffsets;
	SInt32* fOffset;
}


struct WritingCode
{
	short theScriptCode;
	short theLangCode;
}


struct IntlText
{
	short theScriptCode;
	short theLangCode;
	char* theText;
}

