/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 21, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coreservices.ae.AEUserTermTypes;

//import dstep.AvailabilityMacros;
import dstep.coreservices.carboncore.CarbonCore;
import dstep.objc.bridge.TypeEncoding;


// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __kAEUserTerminology = getOSType!("aeut");
		const __kAETerminologyExtension = getOSType!("aete");
		const __kAEScriptingSizeResource = getOSType!("scsz");
		const __kAEOSAXSizeResource = getOSType!("osiz");

	}
}

enum
{
	kAEUserTerminology = getOSType!("aeut"),
	kAETerminologyExtension = getOSType!("aete"),
	kAEScriptingSizeResource = getOSType!("scsz"),
	kAEOSAXSizeResource = getOSType!("osiz")
}

enum
{
	kAEUTHasReturningParam = 31,
	kAEUTOptional = 15,
	kAEUTlistOfItems = 14,
	kAEUTEnumerated = 13,
	kAEUTReadWrite = 12,
	kAEUTChangesState = 12,
	kAEUTTightBindingFunction = 12,
	kAEUTEnumsAreTypes = 11,
	kAEUTEnumListIsExclusive = 10,
	kAEUTReplyIsReference = 9,
	kAEUTDirectParamIsReference = 9,
	kAEUTParamIsReference = 9,
	kAEUTPropertyIsReference = 9,
	kAEUTNotDirectParamIsTarget = 8,
	kAEUTParamIsTarget = 8,
	kAEUTApostrophe = 3,
	kAEUTFeminine = 2,
	kAEUTMasculine = 1,
	kAEUTPlural = 0
}

enum
{
	kLaunchToGetTerminology = (1 << 15),
	kDontFindAppBySignature = (1 << 14),
	kAlwaysSendSubject = (1 << 13)
}

enum
{
	kReadExtensionTermsMask = (1 << 15)
}

enum
{
	kOSIZDontOpenResourceFile = 15,
	kOSIZdontAcceptRemoteEvents = 14,
	kOSIZOpenWithReadPermission = 13,
	kOSIZCodeInSharedLibraries = 11
}

struct TScriptingSizeResource
{
	short scriptingSizeFlags;
	uint minStackSize;
	uint preferredStackSize;
	uint maxStackSize;
	uint minHeapSize;
	uint preferredHeapSize;
	uint maxHeapSize;
}

