/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSJavaSetup;

import dstep.foundation.NSArray;
import dstep.foundation.NSBundle;
import dstep.foundation.NSDictionary;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import bindings = dstep.foundation.NSJavaSetup_bindings;

bool NSJavaNeedsVirtualMachine (NSDictionary plist)
{
	return Bridge.invokeObjcFunction!(bool, bindings.NSJavaNeedsVirtualMachine, NSDictionary)(plist);
}

bool NSJavaProvidesClasses (NSDictionary plist)
{
	return Bridge.invokeObjcFunction!(bool, bindings.NSJavaProvidesClasses, NSDictionary)(plist);
}

bool NSJavaNeedsToLoadClasses (NSDictionary plist)
{
	return Bridge.invokeObjcFunction!(bool, bindings.NSJavaNeedsToLoadClasses, NSDictionary)(plist);
}

Object NSJavaSetup (NSDictionary plist)
{
	return Bridge.invokeObjcFunction!(Object, bindings.NSJavaSetup, NSDictionary)(plist);
}

Object NSJavaSetupVirtualMachine ()
{
	return Bridge.invokeObjcFunction!(Object, bindings.NSJavaSetupVirtualMachine);
}

Object NSJavaObjectNamedInPath (NSString name, NSArray path)
{
	return Bridge.invokeObjcFunction!(Object, bindings.NSJavaObjectNamedInPath, NSString, NSArray)(name, path);
}

NSArray NSJavaClassesFromPath (NSArray path, NSArray wanted, bool usesyscl, id* vm)
{
	return Bridge.invokeObjcFunction!(NSArray, bindings.NSJavaClassesFromPath, NSArray, NSArray, bool, id*)(path, wanted, usesyscl, vm);
}

NSArray NSJavaClassesForBundle (NSBundle bundle, bool usesyscl, id* vm)
{
	return Bridge.invokeObjcFunction!(NSArray, bindings.NSJavaClassesForBundle, NSBundle, bool, id*)(bundle, usesyscl, vm);
}

Object NSJavaBundleSetup (NSBundle bundle, NSDictionary plist)
{
	return Bridge.invokeObjcFunction!(Object, bindings.NSJavaBundleSetup, NSBundle, NSDictionary)(bundle, plist);
}

void NSJavaBundleCleanup (NSBundle bundle, NSDictionary plist)
{
	return Bridge.invokeObjcFunction!(void, bindings.NSJavaBundleCleanup, NSBundle, NSDictionary)(bundle, plist);
}

