/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CIImageAccumulator;

import dstep.applicationservices.coregraphics.CGGeometry;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.quartzcore.CIImage;

class CIImageAccumulator : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	static CIImageAccumulator imageAccumulatorWithExtent (CGRect r, int f)
	{
		return invokeObjcSelfClass!(CIImageAccumulator, "imageAccumulatorWithExtent:format:", CGRect, int)(r, f);
	}

	CIImageAccumulator initWithExtent (CGRect r, int f)
	{
		id result = invokeObjcSelf!(id, "initWithExtent:format:", CGRect, int)(r, f);
		return result is this.objcObject ? this : (result !is null ? new CIImageAccumulator(result) : null);
	}

	this (CGRect r, int f)
	{
		super(CIImageAccumulator.alloc.initWithExtent(r, f).objcObject);
	}

	CGRect extent ()
	{
		return invokeObjcSelf!(CGRect, "extent");
	}

	int format ()
	{
		return invokeObjcSelf!(int, "format");
	}

	CIImage image ()
	{
		return invokeObjcSelf!(CIImage, "image");
	}

	void setImage (CIImage im)
	{
		return invokeObjcSelf!(void, "setImage:", CIImage)(im);
	}

	void setImage (CIImage im, CGRect r)
	{
		return invokeObjcSelf!(void, "setImage:dirtyRect:", CIImage, CGRect)(im, r);
	}

	void clear ()
	{
		return invokeObjcSelf!(void, "clear");
	}
}

