/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CVPixelFormatDescription;

import dstep.corefoundation.CFArray;
import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFDictionary;
import dstep.corevideo.CVPixelBuffer;
import dstep.corevideo.CVPixelFormatDescription;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

extern (C)
{
	alias ubyte function (CVPixelBufferRef, void*) CVFillExtendedPixelsCallBack;
}

extern (C)
{
	extern
	{
		const CFStringRef kCVPixelFormatName;
		const CFStringRef kCVPixelFormatConstant;
		const CFStringRef kCVPixelFormatCodecType;
		const CFStringRef kCVPixelFormatFourCC;
		const CFStringRef kCVPixelFormatPlanes;
		const CFStringRef kCVPixelFormatBlockWidth;
		const CFStringRef kCVPixelFormatBlockHeight;
		const CFStringRef kCVPixelFormatBitsPerBlock;
		const CFStringRef kCVPixelFormatBlockHorizontalAlignment;
		const CFStringRef kCVPixelFormatBlockVerticalAlignment;
		const CFStringRef kCVPixelFormatHorizontalSubsampling;
		const CFStringRef kCVPixelFormatVerticalSubsampling;
		const CFStringRef kCVPixelFormatOpenGLFormat;
		const CFStringRef kCVPixelFormatOpenGLType;
		const CFStringRef kCVPixelFormatOpenGLInternalFormat;
		const CFStringRef kCVPixelFormatCGBitmapInfo;
		const CFStringRef kCVPixelFormatQDCompatibility;
		const CFStringRef kCVPixelFormatCGBitmapContextCompatibility;
		const CFStringRef kCVPixelFormatCGImageCompatibility;
		const CFStringRef kCVPixelFormatOpenGLCompatibility;
		const CFStringRef kCVPixelFormatFillExtendedPixelsCallback;
	}
}

struct CVFillExtendedPixelsCallBackData
{
	int version_;
	CVFillExtendedPixelsCallBack fillCallBack;
	void* refCon;
}

extern (C)
{
	CFDictionaryRef CVPixelFormatDescriptionCreateWithPixelFormatType (CFAllocatorRef allocator, uint pixelFormat);
	CFArrayRef CVPixelFormatDescriptionArrayCreateWithAllPixelFormatTypes (CFAllocatorRef allocator);
	void CVPixelFormatDescriptionRegisterDescriptionWithPixelFormatType (CFDictionaryRef description, uint pixelFormat);
}