/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.security.oidscrl;

import dstep.security.cssmconfig;
import dstep.security.cssmtype;
import dstep.security.oidsbase;

extern (C):

extern const CSSM_OID
/* CRL OIDs */
CSSMOID_X509V2CRLSignedCrlStruct,
CSSMOID_X509V2CRLSignedCrlCStruct,
CSSMOID_X509V2CRLTbsCertListStruct,
CSSMOID_X509V2CRLTbsCertListCStruct,
CSSMOID_X509V2CRLVersion,
CSSMOID_X509V1CRLIssuerStruct,
CSSMOID_X509V1CRLIssuerNameCStruct,
CSSMOID_X509V1CRLIssuerNameLDAP,
CSSMOID_X509V1CRLThisUpdate,
CSSMOID_X509V1CRLNextUpdate,

/* CRL Entry (CRL CertList) OIDS */
CSSMOID_X509V1CRLRevokedCertificatesStruct,
CSSMOID_X509V1CRLRevokedCertificatesCStruct,
CSSMOID_X509V1CRLNumberOfRevokedCertEntries,
CSSMOID_X509V1CRLRevokedEntryStruct,
CSSMOID_X509V1CRLRevokedEntryCStruct,
CSSMOID_X509V1CRLRevokedEntrySerialNumber,
CSSMOID_X509V1CRLRevokedEntryRevocationDate,

/* CRL Entry (CRL CertList) Extension OIDs */
CSSMOID_X509V2CRLRevokedEntryAllExtensionsStruct,
CSSMOID_X509V2CRLRevokedEntryAllExtensionsCStruct,
CSSMOID_X509V2CRLRevokedEntryNumberOfExtensions,
CSSMOID_X509V2CRLRevokedEntrySingleExtensionStruct,
CSSMOID_X509V2CRLRevokedEntrySingleExtensionCStruct,
CSSMOID_X509V2CRLRevokedEntryExtensionId,
CSSMOID_X509V2CRLRevokedEntryExtensionCritical,
CSSMOID_X509V2CRLRevokedEntryExtensionType,
CSSMOID_X509V2CRLRevokedEntryExtensionValue,

/* CRL Extension OIDs */
CSSMOID_X509V2CRLAllExtensionsStruct,
CSSMOID_X509V2CRLAllExtensionsCStruct,
CSSMOID_X509V2CRLNumberOfExtensions,
CSSMOID_X509V2CRLSingleExtensionStruct,
CSSMOID_X509V2CRLSingleExtensionCStruct,
CSSMOID_X509V2CRLExtensionId,
CSSMOID_X509V2CRLExtensionCritical,
CSSMOID_X509V2CRLExtensionType,

/* OCSP */
CSSMOID_PKIX_OCSP,
CSSMOID_PKIX_OCSP_BASIC,
CSSMOID_PKIX_OCSP_NONCE,
CSSMOID_PKIX_OCSP_CRL,
CSSMOID_PKIX_OCSP_RESPONSE,
CSSMOID_PKIX_OCSP_NOCHECK,
CSSMOID_PKIX_OCSP_ARCHIVE_CUTOFF,
CSSMOID_PKIX_OCSP_SERVICE_LOCATOR;